<!-- HTML header for doxygen 1.8.18-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=9" />
    <meta name="generator" content="Doxygen 1.9.1" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>VizBlocks: Link Class Reference</title>
    <link href="tabs.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript" src="jquery.js"></script>
    <script type="text/javascript" src="dynsections.js"></script>
     <link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
    <link href="my_customdoxygen.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <div id="top">
      <!-- do not remove this div, it is closed by doxygen! -->
      <header id="header" class="desktop">
        <div>
          <div class="inner-header">
            <div class="logotype">
              <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" aria-hidden="true" title="Site home"
                >VizBlocks</a
              >
            </div>
            <div class="navigation">
              <button
                onclick="toggleBurger()"
                type="button"
                aria-label="toggle burger menu"
              >
                <i class="fa fa-bars"></i>
              </button>
              <nav id="menu" class="collapse">
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" class="home">Home</a>
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/about" class="about">About</a>
                <a
                  href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials/0_getting_started.html"
                  class="start"
                  >Get Started</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials" class="tutorials"
                  >Tutorials</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/docs/html" class="docs"
                  >Technical Info</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/contact" class="content">Contact</a>
              </nav>
            </div>
          </div>
        </div>
        <script>
          const toggleBurger = () => {
            const menu = document.getElementById("menu");
            if (menu.className === "collapse") {
              menu.className = "extend";
            } else {
              menu.className = "collapse";
            }
          };
          const touchDevice = "ontouchstart" in document.documentElement;
          if (touchDevice) {
            const header = document.getElementById("header");
            header.className = "mobile";
          }
        </script>
      </header>
      <!-- end header part -->
    </div>
  </body>
</html>
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="class_link-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Link Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Experimental <a class="el" href="class_behaviour.html" title="Parent class for all other behaviours.">Behaviour</a> leverages the ability to deliver commands over serial. If a block is connected to another via TX -&gt; RX pins, it can deliver this command and connected block will message the server that they have linked together. If the blocks unlink the behaviour will time out and an unlink message will be sent.  
 <a href="class_link.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_comms_behaviours_8h_source.html">CommsBehaviours.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Link:</div>
<div class="dyncontent">
 <div class="center">
  <img src="class_link.png" usemap="#Link_map" alt=""/>
  <map id="Link_map" name="Link_map">
<area href="class_behaviour.html" title="Parent class for all other behaviours." alt="Behaviour" shape="rect" coords="0,0,70,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a6d9f3f3139b5325cefe19af730d9bc54"><td class="memItemLeft" align="right" valign="top">char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_link.html#a6d9f3f3139b5325cefe19af730d9bc54">args</a> ()</td></tr>
<tr class="separator:a6d9f3f3139b5325cefe19af730d9bc54"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a15f2732bd84cbd364ccdb8aaf310a7e5"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_link.html#a15f2732bd84cbd364ccdb8aaf310a7e5">Link</a> (<a class="el" href="class_viz_block.html">VizBlock</a> *node, String <a class="el" href="class_behaviour.html#a766009be6f0ed1acd74d4ba5c138a7bd">name</a>=&quot;Link&quot;)</td></tr>
<tr class="separator:a15f2732bd84cbd364ccdb8aaf310a7e5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a758369a0b6dd6e9460a7883b83d8969f"><td class="memItemLeft" align="right" valign="top">String&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_link.html#a758369a0b6dd6e9460a7883b83d8969f">start</a> (String <a class="el" href="class_link.html#a6d9f3f3139b5325cefe19af730d9bc54">args</a>)</td></tr>
<tr class="separator:a758369a0b6dd6e9460a7883b83d8969f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4212a26ee2583b08e2307e7385b9a548"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_link.html#a4212a26ee2583b08e2307e7385b9a548">update</a> ()</td></tr>
<tr class="separator:a4212a26ee2583b08e2307e7385b9a548"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_class_behaviour"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_class_behaviour')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="class_behaviour.html">Behaviour</a></td></tr>
<tr class="memitem:aa09d1af17d15fa0c204f2b713e46fba0 inherit pub_methods_class_behaviour"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#aa09d1af17d15fa0c204f2b713e46fba0">Behaviour</a> (String <a class="el" href="class_behaviour.html#a766009be6f0ed1acd74d4ba5c138a7bd">name</a>)</td></tr>
<tr class="separator:aa09d1af17d15fa0c204f2b713e46fba0 inherit pub_methods_class_behaviour"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0f976beeea75cc999f4ce5cbdc889d54 inherit pub_methods_class_behaviour"><td class="memItemLeft" align="right" valign="top">virtual boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a0f976beeea75cc999f4ce5cbdc889d54">is_background</a> ()</td></tr>
<tr class="separator:a0f976beeea75cc999f4ce5cbdc889d54 inherit pub_methods_class_behaviour"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6194e394bab5d264e333b6962173064d inherit pub_methods_class_behaviour"><td class="memItemLeft" align="right" valign="top">virtual boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a6194e394bab5d264e333b6962173064d">is_interruptable</a> ()</td></tr>
<tr class="separator:a6194e394bab5d264e333b6962173064d inherit pub_methods_class_behaviour"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2c47f0e25b4084939bd5cb5f78012385 inherit pub_methods_class_behaviour"><td class="memItemLeft" align="right" valign="top">virtual boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a2c47f0e25b4084939bd5cb5f78012385">is_priority</a> ()</td></tr>
<tr class="separator:a2c47f0e25b4084939bd5cb5f78012385 inherit pub_methods_class_behaviour"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a629c91d3771c7938b22ff393b95518ef inherit pub_methods_class_behaviour"><td class="memItemLeft" align="right" valign="top">virtual boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a629c91d3771c7938b22ff393b95518ef">is_running</a> ()</td></tr>
<tr class="separator:a629c91d3771c7938b22ff393b95518ef inherit pub_methods_class_behaviour"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0d07ba942e21d9d368c5e3837de068b3 inherit pub_methods_class_behaviour"><td class="memItemLeft" align="right" valign="top">virtual boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a0d07ba942e21d9d368c5e3837de068b3">is_temp</a> ()</td></tr>
<tr class="separator:a0d07ba942e21d9d368c5e3837de068b3 inherit pub_methods_class_behaviour"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a766009be6f0ed1acd74d4ba5c138a7bd inherit pub_methods_class_behaviour"><td class="memItemLeft" align="right" valign="top">virtual String&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a766009be6f0ed1acd74d4ba5c138a7bd">name</a> ()</td></tr>
<tr class="separator:a766009be6f0ed1acd74d4ba5c138a7bd inherit pub_methods_class_behaviour"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a56f7e55bee64010414c07deb79426a9b inherit pub_methods_class_behaviour"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a56f7e55bee64010414c07deb79426a9b">stop</a> ()</td></tr>
<tr class="separator:a56f7e55bee64010414c07deb79426a9b inherit pub_methods_class_behaviour"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab9099279876aa70410ab96ca589531df inherit pub_methods_class_behaviour"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#ab9099279876aa70410ab96ca589531df">~Behaviour</a> ()</td></tr>
<tr class="separator:ab9099279876aa70410ab96ca589531df inherit pub_methods_class_behaviour"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_attribs_class_behaviour"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_class_behaviour')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="class_behaviour.html">Behaviour</a></td></tr>
<tr class="memitem:a93c2dc62b373e7d4b58c7cebded12f16 inherit pro_attribs_class_behaviour"><td class="memItemLeft" align="right" valign="top">boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a93c2dc62b373e7d4b58c7cebded12f16">_background</a> = false</td></tr>
<tr class="separator:a93c2dc62b373e7d4b58c7cebded12f16 inherit pro_attribs_class_behaviour"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab26c8020df403d81ff28d13e22b61c81 inherit pro_attribs_class_behaviour"><td class="memItemLeft" align="right" valign="top">boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#ab26c8020df403d81ff28d13e22b61c81">_interruptable</a> = true</td></tr>
<tr class="separator:ab26c8020df403d81ff28d13e22b61c81 inherit pro_attribs_class_behaviour"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad6628fb93079b0f8e2ef4412a9046416 inherit pro_attribs_class_behaviour"><td class="memItemLeft" align="right" valign="top">String&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#ad6628fb93079b0f8e2ef4412a9046416">_name</a> = &quot;name&quot;</td></tr>
<tr class="separator:ad6628fb93079b0f8e2ef4412a9046416 inherit pro_attribs_class_behaviour"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af1f8d319677a6935c28acbbea643c46c inherit pro_attribs_class_behaviour"><td class="memItemLeft" align="right" valign="top">boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#af1f8d319677a6935c28acbbea643c46c">_priority</a> = false</td></tr>
<tr class="separator:af1f8d319677a6935c28acbbea643c46c inherit pro_attribs_class_behaviour"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4397ea529500c0c3259777ffa4a6bad2 inherit pro_attribs_class_behaviour"><td class="memItemLeft" align="right" valign="top">boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a4397ea529500c0c3259777ffa4a6bad2">_running</a> = false</td></tr>
<tr class="separator:a4397ea529500c0c3259777ffa4a6bad2 inherit pro_attribs_class_behaviour"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acbe345ebc552c4f6875ec845d2697f9f inherit pro_attribs_class_behaviour"><td class="memItemLeft" align="right" valign="top">boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#acbe345ebc552c4f6875ec845d2697f9f">_temp</a> = false</td></tr>
<tr class="separator:acbe345ebc552c4f6875ec845d2697f9f inherit pro_attribs_class_behaviour"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Experimental <a class="el" href="class_behaviour.html" title="Parent class for all other behaviours.">Behaviour</a> leverages the ability to deliver commands over serial. If a block is connected to another via TX -&gt; RX pins, it can deliver this command and connected block will message the server that they have linked together. If the blocks unlink the behaviour will time out and an unlink message will be sent. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a15f2732bd84cbd364ccdb8aaf310a7e5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a15f2732bd84cbd364ccdb8aaf310a7e5">&#9670;&nbsp;</a></span>Link()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Link::Link </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_viz_block.html">VizBlock</a> *&#160;</td>
          <td class="paramname"><em>node</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">String&#160;</td>
          <td class="paramname"><em>name</em> = <code>&quot;Link&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a6d9f3f3139b5325cefe19af730d9bc54"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6d9f3f3139b5325cefe19af730d9bc54">&#9670;&nbsp;</a></span>args()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">char* Link::args </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>What arguments does the behaviour take? Override this to document your behaviour. </p>

<p>Reimplemented from <a class="el" href="class_behaviour.html#ad5aa6388bf5b47911ae801ebbf82e35d">Behaviour</a>.</p>

</div>
</div>
<a id="a758369a0b6dd6e9460a7883b83d8969f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a758369a0b6dd6e9460a7883b83d8969f">&#9670;&nbsp;</a></span>start()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">String Link::start </td>
          <td>(</td>
          <td class="paramtype">String&#160;</td>
          <td class="paramname"><em>args</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Start the behaviour, with arguments. </p>

<p>Reimplemented from <a class="el" href="class_behaviour.html#ab4bc4b2d9d9ec727fd84796c6c6d44b3">Behaviour</a>.</p>

</div>
</div>
<a id="a4212a26ee2583b08e2307e7385b9a548"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4212a26ee2583b08e2307e7385b9a548">&#9670;&nbsp;</a></span>update()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Link::update </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Update the behaviour periodically. </p>

<p>Reimplemented from <a class="el" href="class_behaviour.html#a4b8190a1a262ab969fd7706cc55906c6">Behaviour</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>src/<a class="el" href="_comms_behaviours_8h_source.html">CommsBehaviours.h</a></li>
</ul>
</div><!-- contents -->
<!-- HTML footer for doxygen 1.8.18-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.9.1
</small></address>
</body>
</html>
